## [0.12 Unreleased]

## [0.11] - 2024-06-22
### Changed
Calendar sync extended with support for providers that work with basicauth.
Tested providers GMX and Yahoo. Google calendar still supported. Provider
specifc changes:
* replace `google_calendar` config key with `caldav_calendar`
* extract caldav host without path as basis for further api paths
* fix start/end filter in event report request
* Google auth scope `calendar.events.owned` replaced by `calendar.events`
  (https://developers.google.com/calendar/api/auth)

Documentation updates:
* doc(man): update scdoc `SOURCE_DATE_EPOCH`
* doc(lttng): create channel before starting session. The live sessions needs a
  channel first before start. Otherwise, Error: No channel found in the session
* doc(google): update api scopes
* doc(readme): update issue board
* doc(nix): document nix build/install
* doc(nix): prefetch latest commit hash

Other various changes and fixes:
* feat: improve error handling
* fix(folding): missing CR
* fix(caldav): bearer token buffer overflow
* doc(#96): advise dedicated calendar for caldav sync
  (https://board.in0rdr.ch/public/task/96/adedb4a1f31d1e5116b600c1c9dc225db8675d125f071758913a9570c383)

### Added
CalDAV sync support for basicauth providers (tested with Yahoo, GMX). Changes
to support the providers.

GMX:
* follow redirects during principal discovery
* add missing ics fields for upload
* add missing etag prop for calendar retrieval
* relax xml token search and parsing
* bug(#97) description: unfolding - escaped CR
  (https://board.in0rdr.ch/public/task/97/adedb4a1f31d1e5116b600c1c9dc225db8675d125f071758913a9570c383)
  Bug in the download part. All ics fields in the xml response have the carriage
  return html escape sequence '&#13;' Unfortunately this escape sequence is not
  handled correctly on our side yet and saved to the text file on disk. All
  other caldav server implementations only send '\n' at the end of each ics line.

Yahoo:
* fix several printf buffer overflows
* fix xml parsing functions to not assume xml namespace, can be different
  depending on the provider
* fix wrong caldav report depth header fields
* fix wrong caldav request time-range xml filter that synced down the event
  from the next day to the currently selected day
* fix missing CR while unfolding
* send proper content-type
* new lttng `debug_long` tracepoint
* improve homeset and calendar requests
* replace LAST-MODIFIED with DTSTAMP, because LAST-MODIFIED is not available on
  all providers

Scripts and documentation for Nix:
* Nix shell for development setups including build and documentation utilities
* Nix stdenv build scripts for stable/unstable build files

## [0.10] - 2024-04-15
* fix: use addstr without fmt
* Update IRC channel in man page

## [0.9] - 2023-10-08

### Changed
* Increase token size to max. advertised in the Google API docs:
  https://developers.google.com/identity/protocols/oauth2#size
* Fixes bugs while drawing days before/after the DST change and in the
  movements between these boundaries

### Added
* feat(lttng): add debug_tm tracepoint
* feat: replace usleep with nanosleep

## [0.8] - 2023-03-26

### Notes
* This is a bugfix release

### Changed
* Fix caldav access/refresh token size
* Fix caldav postfield size (port)
* Fix wrong date marks in ics import
* Fix minor typos in docs and confirmation screen
* Fix Makefile target exec rights

### Added
* Improve docs for obs project and caldav API

## [0.7] - 2023-02-20

### Changed
* #15: Fix segfault when no remote google_calendar
* #12: Prevent overflow in display_entry
* #11: Fix repeated 'S' key press
* #10: Fix malloc for google_tokenfile
* #3: Improve handling for tokenfile when offline (Caldav sync)
* Move source code from Codeberg

### Added
* #6/7: LTTng instrumentation for development and debugging purposes

## [0.6] - 2022-02-02

### Changed
* Changed "s" shortcut logic: "s" no longer jumps to specific day (search), use
  "f" to "find" date (drop-in replacement). Use "s" to "sync" entries to Google
  calendar (CalDAV sync).
* Move source code from GitHub to Codeberg
* Simplify man page generation with [scdoc](https://sr.ht/~sircmpwn/scdoc/)
* Fix segfault at a first run (#1)

### Added
* External text format command (#68, #80) `--fmt-cmd`
* Pseudo-terminal to support ANSI escape characters (colors, font types, etc.)
  and `--no-pty` option (#6, #44, #5)
* Mouse support for selecting dates (#60)
* Documentation of Open Build Service (OBS) jobs (`docs/OBS.md`)
* Documentation of testing and debugging procedures (`docs/TESTING.md`)
* Add `debug` target to `Makefile`
* CalDAV sync: "s"/"S" shortcuts to sync selected day/Month with Google
  calendar
* Import (#76, #77): "i" shortcut to import entries from .ics
* Export (#78): "E" shortcut to export entries to .ics

## [0.5] - 2021-02-24

### Changed
* Make year range (#56), first weekday (#13) and file name configurable
* Change g/G shortcut logic: Jump to first/last non-empty entry (#57)
* Improve man page and overall documentation

### Added
* Add optional configuration file (#35)
* Add command line options (#34), help and version flags (#45)

## [0.4] - 2020-10-17

### Changed
* Fix install on OSX (#41)
* Improve Makefile and build instructions

## [0.3] - 2016-12-28

### Changed
* Escape characters and utf-8 fixes
* First day of week according to locale

### Added
* Header file
* Constant parameters
* Jump to nearest entry
* Man page

## [0.2] - 2016-11-27

### Changed
* Fixes trailing '/' in entry reading

### Added
* Remove entries
* Search entries, jump to date

## [0.1] - 2016-11-24

### Notes
* There is still a bug which appends '/' to the diary directory even if the
  trailing '/' is already given.
* Removing entries not yet possible
