# Nix documentation
Follow the instructions here when developing or building on/for Nix.

## Notes for nightly builds
Before building or installing the unstable release, replace the hash of the
current HEAD in the nix expression file.

```bash
hash=$(nix-prefetch-git --quiet https://git.in0rdr.ch/diary.git | jq -r .hash)
sed -i "s~<PREFETCH_HASH>~$hash~" nix/diary-unstable.nix
```

## Build instructions
To build the (un)stable packages for Nix:

```bash
# Build stable package
nix-build nix/diary.nix

# Build latest nightly version
nix-build nix/diary-unstable.nix
```

## Installation instructions
To install the package from the expression file to the user environment:
```bash
# Install stable package
nix-env -i -f nix/diary.nix

# Install latest nightly version
nix-env -i -f nix/diary-unstable.nix
```

## Development environment
To prepare a nix shell as a dev environment, use the `shell.nix`:
* https://nixos.wiki/wiki/Development_environment_with_nix-shell

```bash
cd nix
nix-shell
```
